# Storyboarder

Storyboarder makes it easy to visualize a story as fast you can draw stick figures. Quickly draw to test if a story idea works. Create and show animatics to others. Express your story idea without making a movie.

[![screenshot](https://user-images.githubusercontent.com/441117/27712058-4404e214-5cf3-11e7-8fa3-b88ae924d154.gif)](https://www.wonderunit.com/storyboarder)

Whether you are a story artist, writer, director, in advertising, or just a person with an idea, you can use this to quickly make storyboards.

## Download

### [Click here to download the latest release](https://wonderunit.com/storyboarder/)

[PLEASE PLEASE PLEASE submit issues with bugs, ideas, suggestions, or any feedback! Thanks!](https://github.com/wonderunit/storyboarder/issues)

Also, if this project seems interesting, could you press that star button at the top right? Thanks!!!!

## It's easy...

1. Start a blank storyboard or open a Fountain screenplay.
2. Start drawing boards using a mouse or wacom open. Or print out
3. Flip through the boards, play it back, pitch it, make changes.

Don't get slowed down by too many buttons or options. You're here to board stories, not make the next Moner Lisa.

Works with Pens on any tablet or Cintiq or even a Microsoft Surface. Also works with a mouse.

## Features:

* Simple, Smooth Drawing
* Super Simple Interface
* Printed Worksheets
* Works with Wacom
* Easy Organization
* Draw Straight Lines
* Works with Fountain
* Open in Photoshop
* Measure Line Mileage
* Guides to Help Drawing
* Reference Layer
* Onion Skin
* Track changes
* Collaborate on Github
* Export to various Formats

## We have 4 brush types which are all you need to draw fast:

* **Light pencil** for roughing
* **Pencil** for fast sketching
* **Pen** for inking strong lines
* **Brush** for filling in some shading

You can also specificy 3 brush sizes for each type.

Each brush has its own 5 color pallete. You can set all the colors as you like.

There are no layers. Again, you're boarding story ideas. Managing layers creates so much unneeded complexity and UI mess. A board artist that uses layers probably voted for Trump - or paid way too much for "Pro" storyboard software.

Made a mistake? You can erase that shit.

You can undo and redo.

Made a big mistake? You can clear the whole thing.

If it's off center or too big or too small, you can shift your drawing around or scale it.

Need a straight line? Hold shift while you're drawing and you got straight lines.

## There are 5 guide overlays to toggle:

*  Grid
*  Center Marks
*  Thirds
*  Angles
*  Onion skin (previous and next board in shot)

## We got mad simple key commands:

* Light Pencil: <kbd>1</kbd>
* Pencil: <kbd>2</kbd>
* Pen: <kbd>3</kbd>
* Brush: <kbd>4</kbd>
* Eraser: <kbd>5</kbd>
* Clear: <kbd>Delete</kbd> or <kbd>Backspace</kbd>
* Undo: <kbd>Cmd</kbd>+<kbd>z</kbd>
* Redo: <kbd>Cmd</kbd>+<kbd>y</kbd>
* Smaller Brush: <kbd>[</kbd>
* Bigger Brush: <kbd>]</kbd>
* Straight Lines: <kbd>Hold shift while drawing</kbd>
* Move Contents: <kbd>Hold command</kbd>
* Scale Contents: <kbd>Cmd</kbd>+<kbd>Option</kbd>
* Color Pick: <kbd>Hold Option</kbd>

## FAQ

**"CHARLES, I RESPEKT UR OPINIONATED SOFTWARE DESIGN GANGSTER, BUT I NEED TO POLISH MY DRAWINGS TIGHTER."**
No problem, needy bruh. You can click a button to edit in photoshop, and when you save, it updates in Storyboarder.

**"CHARLES, STORYBOARDER IS REVOLUTIONARY. PERHAPS BIGGER THAN JESUS AND WRESTLING. - Saul Bass"**
Fuck you, Saul Bass. Absolutely bigger than Jesus and wrestling. Also, your work output has really dropped off in recent years.

**"HOW COME WHEN I'M DRAWING, I HEAR THE IMPERIAL MARCH?"**
You're probably boarding on the Simpsons. You might want to escape North Korea through China. If not shot crossing the river, you will probably be sold into slavery by the Chinese. Work for 5 years, buy your freedom and make your way to Seoul. This should fix your issue. You're welcome.

## Notes on Open Source License

https://wonderunit.com/thoughts-on-free-and-open-source/

## Contributers

We would love help on this project. If you are interested in helping out feel free to email charles@wonderunit.com or submit a PR.
